---
import "./languageSwitcher.sass";
import { getLangFromUrl } from "../../../i18n/utils.ts";
const lang = getLangFromUrl(Astro.url);
---

<div class="i18n">
  <span
    role="button"
    tabindex={0}
    class="i18n__fr"
    title="Voir le site en français"
  >
    Fr
  </span>
  <div
    class="i18n__select"
    data-lang={lang}
    style="width:39px;verticalAlign: middle"
  >
  </div>
  <span
    role="button"
    tabindex={0}
    class="i18n__en"
    title="View the website in English"
  >
    En
  </span>
</div>
<script>
  import lottie from "lottie-web";
  const frButton = document.getElementsByClassName("i18n__fr")[0];
  const enButton = document.getElementsByClassName("i18n__en")[0];
  const lottieBtn = document.getElementsByClassName(
    "i18n__select"
  )[0] as HTMLElement;
  const lang = lottieBtn.dataset.lang;
  const options = {
    container: lottieBtn,
    path: "/toggle.json",
    autoplay: false,
    loop: false,
  };
  const lottieObj = lottie.loadAnimation(options);

  frButton.addEventListener("click", (event) => handleTextClick("fr", event));
  enButton.addEventListener("click", (event) => handleTextClick("en", event));
  lottieBtn.addEventListener("click", handleLottieClick);
  function setToggleButton(value: string) {
    if (value == "en") {
      lottieObj.setDirection(1);
      lottieObj.play();
      //@ts-ignore
      window.location = "/";
    }
    if (value == "fr") {
      lottieObj.setDirection(-1);
      lottieObj.play();
      //@ts-ignore
      window.location = "/fr";
    }
  }
  function handleLottieClick() {
    if (lang === "fr") {
      setToggleButton("en");
    } else if (lang === "en") {
      setToggleButton("fr");
    }
  }
  function handleTextClick(value: string, event: Event) {
    if (event.type == "keydown") {
      let keyboardEvent = event as KeyboardEvent;
      if (keyboardEvent.code !== "Enter" && keyboardEvent.code !== " ") {
        return;
      }
    }
    setToggleButton(value);
  }

  if (lang === "en") {
    lottieObj.setDirection(1);
    lottieObj.play();
  }
</script>
